using System;
using System.IO;
using System.Data;
using System.Data.SqlClient;
using System.Collections;

namespace dotNetBoard
{
	/// <summary>
	/// BoardInfo   Դϴ.
	/// </summary>
	public class BoardInfo
	{
		private string m_sDBServer;
		public string DBServer { get { return m_sDBServer; } set { m_sDBServer = value; } }
		private string m_sDBName;
		public string DBName { get { return m_sDBName; } set { m_sDBName = value; } }
		private string m_sDBUser;
		public string DBUser { get { return m_sDBUser; } set { m_sDBUser = value; } }
		private string m_sDBPassword;
		public string DBPassword { get { return m_sDBPassword; } set { m_sDBPassword = value; } }
		private string m_sAdminPassword;
		public string AdminPassword { get { return m_sAdminPassword; } set { m_sAdminPassword = value; } }

		private Hashtable m_hs;
		public Hashtable Tables { get { return m_hs; } }

		public BoardInfo(string path)
		{
			m_sDBServer = "";
			m_sDBName = "";
			m_sDBUser = "";
			m_sDBPassword = "";
			m_sAdminPassword = "";

			m_hs = new Hashtable();
			Load(path);
		}

		public void Save(string path)
		{
			FileStream		fs = new FileStream(path + "\\dotNetBoardcfg.aspx", FileMode.OpenOrCreate, FileAccess.ReadWrite);
			StreamWriter	tw = new StreamWriter(fs);

			tw.WriteLine("<%@ Page language=\"c#\"%>");
			tw.WriteLine("<% /*");
			tw.WriteLine(m_sDBServer);
			tw.WriteLine(m_sDBName);
			tw.WriteLine(m_sDBUser);
			tw.WriteLine(m_sDBPassword);
			tw.WriteLine(m_sAdminPassword);
			tw.WriteLine("*/ %>");

			tw.Close();
			fs.Close();
		}

		public void Load(string path)
		{
			FileStream		fs;
			
			try
			{
				fs = new FileStream(path + "\\dotNetBoardcfg.aspx", FileMode.OpenOrCreate, FileAccess.ReadWrite);
			}
			catch
			{
				return;
			}
			
			StreamReader	tr = new StreamReader(fs);

			tr.ReadLine();
			tr.ReadLine();
			m_sDBServer = tr.ReadLine();
			m_sDBName = tr.ReadLine();
			m_sDBUser = tr.ReadLine();
			m_sDBPassword = tr.ReadLine();
			m_sAdminPassword = tr.ReadLine();
			tr.ReadLine();

			if(m_sDBServer == null)
				m_sDBServer = "";
			if(m_sDBName == null)
				m_sDBName = "";
			if(m_sDBUser == null)
				m_sDBUser = "";
			if(m_sDBPassword == null)
				m_sDBPassword = "";
			if(m_sAdminPassword == null)
				m_sAdminPassword = "";

			tr.Close();
			fs.Close();

			if(m_sDBServer != "" && m_sDBName != "" && m_sDBUser != "")
			{
				SqlConnection conn = new SqlConnection(GetConnectString());
				string sql = "select * from TBBoardInfo";
				SqlDataAdapter da = new SqlDataAdapter(sql, conn);
				DataSet ds = new DataSet();
				conn.Open();
				da.Fill(ds);
				conn.Close();

				string				key, val;
				for(int i = 0; i < ds.Tables[0].Rows.Count; i++)
				{
					val = (string)(ds.Tables[0].Rows[i]["sTITLE"]);
					key = (string)(ds.Tables[0].Rows[i]["sTABLE"]);

					m_hs.Add(key, val);
				}
			}
		}

		public string GetConnectString()
		{
			return "server=" + m_sDBServer + ";database=" + m_sDBName + ";uid=" + m_sDBUser + ";pwd=" + m_sDBPassword;
		}
	}
}
