using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace dotNetBoard
{
	/// <summary>
	/// WebForm1   Դϴ.
	/// </summary>
	public class List : System.Web.UI.Page
	{
		private DataSet m_ds;
		protected BoardInfo m_bi;
		protected string m_sTitle;

		protected System.Web.UI.WebControls.DataGrid DGList;
		protected System.Web.UI.WebControls.CheckBox CBSearchTitle;
		protected System.Web.UI.WebControls.CheckBox CBSearchBody;
		protected System.Web.UI.WebControls.CheckBox CBSearchName;
		protected System.Web.UI.WebControls.TextBox CSearchWord;
		protected System.Web.UI.WebControls.Label CPageInfo;
		protected System.Web.UI.WebControls.Label CReccnt;
		protected System.Web.UI.WebControls.Button CSearch;

		private void Page_Load(object sender, System.EventArgs e)
		{
			m_bi = new BoardInfo(Server.MapPath("."));
			m_sTitle = "";
			if(Request["db"] != null && Request["db"] != "")
				m_sTitle = m_bi.Tables[Request["db"]].ToString();
			if(!Page.IsPostBack)
			{
				CSearchWord.Text = Request["SearchWord"];
				if(Request["bSearchTitle"] == "False")
					CBSearchTitle.Checked = false;
				if(Request["bSearchBody"] == "False")
					CBSearchBody.Checked = false;
				if(Request["bSearchName"] == "True")
					CBSearchName.Checked = true;

				if(Request["ParentReload"] != null)
				{
					Response.Write("<script>");
					Response.Write("parent.location.href = 'admin.aspx?db=" + Request["db"] + "';");
					Response.Write("</script>");
					return;
				}
			}

			LoadData();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.DGList.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.DGList_PageIndexChanged);
			this.DGList.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.DGList_ItemDataBound);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void DGList_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			int				i;
			TimeSpan		ts = new TimeSpan(1, 0, 0, 0, 0);
			DateTime		dt;

			if(e.Item.DataSetIndex < 0)
				return;

			dt = (DateTime)(m_ds.Tables[0].Rows[e.Item.DataSetIndex]["dUPDATED"]);

			e.Item.Cells[1].Text = "";
			if((int)(m_ds.Tables[0].Rows[e.Item.DataSetIndex]["nGLEVEL"]) > 0)
			{
				for(i = 0; i < (int)(m_ds.Tables[0].Rows[e.Item.DataSetIndex]["nGLEVEL"]); i++)
					e.Item.Cells[1].Text += "&nbsp;&nbsp;&nbsp;";

				e.Item.Cells[1].Text += "<img src='images/re.gif'>";
			}
			if(dt >=  DateTime.Now - ts)
				e.Item.Cells[1].Text += "<img src='images/new.gif'>";
			
			e.Item.Cells[1].Text += " <a href='view.aspx?db=" + Request["db"] + "&code=" + ((int)(m_ds.Tables[0].Rows[e.Item.DataSetIndex]["nCODE"])).ToString() + "&paging=" + DGList.CurrentPageIndex.ToString();
			e.Item.Cells[1].Text += "&SearchWord=" + CSearchWord.Text;
			e.Item.Cells[1].Text += "&bSearchTitle=" + CBSearchTitle.Checked.ToString();
			e.Item.Cells[1].Text += "&bSearchBody=" + CBSearchBody.Checked.ToString();
			e.Item.Cells[1].Text += "&bSearchName=" + CBSearchName.Checked.ToString();
			e.Item.Cells[1].Text += "'>";
			e.Item.Cells[1].Text += (string)(m_ds.Tables[0].Rows[e.Item.DataSetIndex]["sTITLE"]);
			e.Item.Cells[1].Text += "</a>";
		}

		private void DGList_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			DGList.CurrentPageIndex = e.NewPageIndex;
			DGList.DataBind();
		}

		private void LoadData()
		{
			bool ssw = false;

			// ۸ о ׸ Binding
			SqlConnection conn = new SqlConnection(m_bi.GetConnectString());
			string sql = "select nCODE, sTITLE, sNAME, sMAIL, dUPDATED, nREAD, nGLEVEL from " + Request["db"];
			if(CSearchWord.Text != null && CSearchWord.Text != "" && (CBSearchTitle.Checked || CBSearchBody.Checked || CBSearchName.Checked))
			{
				sql += " where";
				if(CBSearchTitle.Checked)
				{
					sql += " sTITLE like '%" + CSearchWord.Text + "%'";
					ssw = true;
				}
				if(CBSearchBody.Checked)
				{
					if(ssw)
						sql += " or";
					sql += " sBODY like '%" + CSearchWord.Text + "%'";
					ssw = true;
				}
				if(CBSearchName.Checked)
				{
					if(ssw)
						sql += " or";
					sql += " sNAME like '%" + CSearchWord.Text + "%'";
				}
			}
			sql += " order by nGROUP desc, nCODE asc";
			SqlDataAdapter da = new SqlDataAdapter(sql, conn);
			m_ds = new DataSet();
			conn.Open();
			da.Fill(m_ds);
			DGList.DataSource = m_ds;
			if(Request["paging"] != null)
				DGList.CurrentPageIndex = int.Parse(Request["paging"]);
			DGList.DataBind();
			conn.Close();

			CPageInfo.Text = (DGList.CurrentPageIndex + 1).ToString() + " / " + DGList.PageCount.ToString() + " page";
			CReccnt.Text = m_ds.Tables[0].Rows.Count.ToString() + " posted.";
		}
	}
}
